package DB;

/** stream-based skeleton class */

import org.omg.PortableServer.POA;
public class ManagerPOATie
	extends ManagerPOA
{
	private ManagerOperations _delegate;

	private POA _poa;
	public ManagerPOATie(ManagerOperations delegate)
	{
		_delegate = delegate;
	}
	public ManagerPOATie(ManagerOperations delegate, POA poa)
	{
		_delegate = delegate;
		_poa = poa;
	}
	public DB.Manager _this()
	{
		return DB.ManagerHelper.narrow(_this_object());
	}
	public DB.Manager _this(org.omg.CORBA.ORB orb)
	{
		return DB.ManagerHelper.narrow(_this_object(orb));
	}
	public ManagerOperations _delegate()
	{
		return _delegate;
	}
	public void _delegate(ManagerOperations delegate)
	{
		_delegate = delegate;
	}
	public void shutdownServer()
	{
_delegate.shutdownServer();
	}

	public DB.Connection getConnection(java.lang.String url, java.lang.String user, java.lang.String password, DB.WarningsHolder warns) throws DB.Exception
	{
		return _delegate.getConnection(url,user,password,warns);
	}

}
